//
//  ViewController.swift
//  DynamicAutoLayoutSample
//
//  Created by Maeda Tasuku on 2/6/16.
//  Copyright © 2016 Kinkuma Design. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    //for Layout 1
    @IBOutlet weak var yellowLeadingConstraint: NSLayoutConstraint!
    @IBOutlet weak var yellowTrailingBlueLeadingConstraint: NSLayoutConstraint!
    @IBOutlet weak var blueTrailingConstraint: NSLayoutConstraint!
    
    //for Layout 2
    @IBOutlet weak var blueLeadingConstraint: NSLayoutConstraint!
    @IBOutlet weak var blueTrailingYellowLeadingConstraint: NSLayoutConstraint!
    @IBOutlet weak var yellowTrailingConstraint: NSLayoutConstraint!
    
    var isLayout1:Bool = true
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    override func viewWillLayoutSubviews() {
        updateViewConstraints()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }

    @IBAction func layoutSegmentValueChanged(sender: AnyObject) {
        let segment:UISegmentedControl = sender as! UISegmentedControl
        isLayout1 = segment.selectedSegmentIndex == 0
        
        updateViewConstraints()
    }
    
    override func updateViewConstraints() {
        if isLayout1 {
            //At first, deactivate layout2
            blueLeadingConstraint.active = false
            blueTrailingYellowLeadingConstraint.active = false
            yellowTrailingConstraint.active = false
            
            //Second, activate layout1
            yellowLeadingConstraint.active = true
            yellowTrailingBlueLeadingConstraint.active = true
            blueTrailingConstraint.active = true
            
            /**
             * You can also deactivate and activate constraints,
             * using NSLayoutConstraint's class methods.
             */
//            NSLayoutConstraint.deactivateConstraints([
//                blueLeadingConstraint,
//                blueTrailingYellowLeadingConstraint,
//                yellowTrailingConstraint
//            ])
//            NSLayoutConstraint.activateConstraints([xxxx,  xxxx,  xxx])
            
        }else{
            //At first, deactivate layout1
            yellowLeadingConstraint.active = false
            yellowTrailingBlueLeadingConstraint.active = false
            blueTrailingConstraint.active = false
            
            //Second, activate layout2
            blueLeadingConstraint.active = true
            blueTrailingYellowLeadingConstraint.active = true
            yellowTrailingConstraint.active = true
        }
        
        super.updateViewConstraints()
    }
}

